package org.postgresql.net;

import java.io.FileInputStream;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;

import javax.swing.BoundedRangeModel;

import net.piraku.sql.ConnectionResource;

public class ConPool {
	static ConPool pool;
	
	public static ConPool getPool() throws Exception {
		if (null==pool) {
			pool = new ConPool();
		}
		return pool;
	}
	
	private final int NUM_CONS;
	private final List<ConnectionResource> connections = new ArrayList<ConnectionResource>();
	private int num;

	
	private final int NUM_WCONS;
	private final List<ConnectionResource> wconnections = new ArrayList<ConnectionResource>();
	private volatile int numw;
	
	
	public ConPool() throws Exception {
		
		Properties props = new Properties();
		try {
			props.load(new FileInputStream("jdbc.properties"));
		} catch (Exception e) {
			
		}
		
		String driver = props.getProperty("jdbc.driver", "org.postgresql.Driver");
		String url = props.getProperty("jdbc.url", "jdbc:postgresql://192.168.0.114:5432/test");
		String usr = props.getProperty("jdbc.user", "postgres");
		String pwd = props.getProperty("jdbc.password", "postgres");
//		String rpoolAuto = props.getProperty("jdbc.rpool.auto-commit", "false");
		String rpoolSize = props.getProperty("jdbc.rpool.size", "8");
		
		NUM_CONS = Integer.parseInt(rpoolSize);
		
		Class.forName(driver);
		
		for (int i=0; i<NUM_CONS; i++) {
			ConnectionResource con = (ConnectionResource) DriverManager.getConnection(url , usr, pwd);
//			con.setAutoCommit(false);
			con.setReadOnly(true);
			connections.add(con);
		}
		
//		String wpoolAuto = props.getProperty("jdbc.wpool.auto-commit", "true");
		String wpoolSize = props.getProperty("jdbc.wpool.size", "8");
		NUM_WCONS = Integer.parseInt(wpoolSize);
//		wconnections = new ArrayBlockingQueue<ConnectionResource>(NUM_WCONS);
		
		for (int i=0; i<NUM_WCONS; i++) {
			ConnectionResource con = (ConnectionResource) DriverManager.getConnection(url , usr, pwd);
			con.setAutoCommit(true);
			con.setReadOnly(false);
			wconnections.add(con);
		}
	}
	
	ConnectionResource getNext() {
		return connections.get(num++%NUM_CONS);
	}
	
	ConnectionResource getNextWriter() {
		return wconnections.get(numw++%NUM_WCONS);
//		try {
//			return wconnections.take();
//		} catch (InterruptedException e) {
//			throw new RuntimeException(e);
//		}
	}
//	
//	void returnWriter(ConnectionResource res) {
//		wconnections.add(res);
//	}
}
