package net.piraku.core.net;

import io.netty.handler.codec.http.DefaultFullHttpResponse;
import io.netty.handler.codec.http.FullHttpRequest;
import io.netty.handler.codec.http.FullHttpResponse;
import io.netty.handler.codec.http.HttpResponseStatus;

import java.util.Arrays;
import java.util.Date;

import net.piraku.core.CoSync;

import com.fasterxml.jackson.databind.ObjectMapper;

public class JsonHelloWorld {
	
	public static class Message {
		private String message = "Hello, World";
		
		public String getMessage() {
			return message;
		}
		public void setMessage(String message) {
			this.message = message;
		}
	}
	
	ObjectMapper mapper = new ObjectMapper();
	
	@CoSync
	public FullHttpResponse service(FullHttpRequest req) throws Exception {
		Message msg = new Message();
		byte[] hello = mapper.writeValueAsBytes(msg);
		DefaultFullHttpResponse res = new DefaultFullHttpResponse(req.getProtocolVersion(), HttpResponseStatus.OK);
		res.headers().add("Content-Type", "application/json; charset=UTF-8");
		res.headers().add("Server", "Example");
		res.headers().add("Date", new Date());
		res.headers().add("Date", new Date());
		res.headers().add("Content-Length", hello.length);
		res.headers().add("Connection", "Keep-Alive");
		
		res.content().writeBytes(hello);
		
		return res;
	}
}
