package org.postgresql;

import java.sql.DriverManager;

import net.piraku.concurrent.FutureResource;
import net.piraku.core.PirakuResource;
import net.piraku.sql.ConnectionResource;
import net.piraku.sql.ResultSetResource;
import net.piraku.sql.StatementResource;

public class Test {
	static void log(String s) {
		System.out.println(""+System.nanoTime()+" - "+s);
	}
	
	public static void main(String[] args) throws Exception {
		Class.forName("org.postgresql.Driver");
		ConnectionResource connection = null;
		String url = "jdbc:postgresql://192.168.0.66:5432/test";
		if (null!=System.getProperty("jdbc.url"))
			url = System.getProperty("jdbc.url");
		
		log("start : "+url);
		connection = (ConnectionResource) DriverManager.getConnection(
		   url,"postgres", "postgres");
		log("got connection");
		
		long ts0 = System.currentTimeMillis();
		int max = 100000;
		PirakuResource last = null;
		
		for (int i=0; i<max; i++) {
//			log(""+i);
//			if (i<(max-20))
				last = time(connection, i);
//			else 
//				time(connection, i);
		}
		
		last.awaitReady();
		
		long ts1 = System.currentTimeMillis();
		
		connection.close();
		System.out.println("closed");
		
		System.out.println("total time: "+(ts1-ts0)+" ms");
		
		System.exit(0);
	}
	
	static PirakuResource time(ConnectionResource connection, final int num) throws Exception {
		final StatementResource stm = connection.createStatement();
//		log("got stm");
		final FutureResource<ResultSetResource> rsFuture = stm.executeQueryAsync("select * from dummy");
//		log("got rs");
		
		rsFuture.registerReadyObserver(new PirakuResource.Observer() {
			
			@Override
			public void onReady(PirakuResource resource) {
				log("done - "+num);
				resource.removeReadyObserver(this);
				try {
					ResultSetResource rs = rsFuture.get();
					while (rs.next()) 
						rs.getString("name");
					rs.close();
					stm.close();
				} catch (Exception e) {
					log("ERROR - "+e.getMessage());
					e.printStackTrace(System.out);
				}
			}
		});
		
		return rsFuture;
		
	}
}
