package org.postgresql;

import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.List;

import net.piraku.concurrent.FutureResource;
import net.piraku.core.PirakuResource;
import net.piraku.sql.ConnectionResource;
import net.piraku.sql.StatementResource;

public class TestPopulate {
	static void log(String s) {
		System.out.println(""+System.nanoTime()+" - "+s);
	}
	
	public static void main(String[] args) throws Exception {
		Class.forName("org.postgresql.Driver");
		int num = 1;
		List<ConnectionResource> cons = new ArrayList<ConnectionResource>();
		List<PirakuResource> lasts = new ArrayList<PirakuResource>();
		
		log("start");
		for (int i=0; i<num; i++) {
			cons.add((ConnectionResource) DriverManager.getConnection(
		   "jdbc:postgresql://192.168.0.54:5432/test","postgres", "postgres"));
			cons.get(i).setAutoCommit(false);
			lasts.add(null);
		}
		
		log("got connections");
		
		int max = 10000;
		
		StatementResource stm = cons.get(0).createStatement();
		
		
		stm.executeUpdate("drop table world");
		stm.executeUpdate("CREATE TABLE world (id int primary key, randomNumber int not null) WITH (fillfactor=50)");
		stm.executeUpdate("DELETE FROM world");
		stm.close();
		cons.get(0).commit();
		
		log("start");
		long ts0 = System.currentTimeMillis();
		for (int i=0; i<max; i++) {
			lasts.set(i%num,  time(cons.get(i%num), i));
		}
		
		for (int i=0; i<num; i++)
			lasts.get(i).awaitReady();

		long ts1 = System.currentTimeMillis();
		
		for (int i=0; i<num; i++)
			lasts.set(i, cons.get(i).commitAsync());
		
		Thread.sleep(1024);
		cons.get(0).commit();
		
		for (int i=0; i<num; i++)
			lasts.get(i).awaitReady();

		for (int i=0; i<num; i++)
			cons.get(i).close();
		
		System.out.println("closed");
		
		System.out.println("total time: "+(ts1-ts0)+" ms for "+num);
		System.out.println("total "+((1.0*max/(ts1-ts0))*1000)+" ts/sec for "+num);
		
		System.exit(0);
	}
	
	static PirakuResource time(ConnectionResource connection, final int num) throws Exception {
		final StatementResource stm = connection.createStatement();
//		log("got stm");
		int i = num;
		final FutureResource<Boolean> rsFuture = stm.executeAsync("INSERT INTO world VALUES("+i+", "+i+")");
//		log("got rs");
		
		rsFuture.registerReadyObserver(new PirakuResource.Observer() {
			
			@Override
			public void onReady(PirakuResource resource) {
				if (num%1000==0)
					log("done - "+num);
				resource.removeReadyObserver(this);
				try {
					stm.close();
				} catch (Exception e) {
					log("ERROR - "+e.getMessage());
					e.printStackTrace(System.out);
				}
			}
		});
		
//		connection.commitAsync().registerReadyObserver(new PirakuResource.Observer() {
//			
//			@Override
//			public void onReady(PirakuResource resource) {
//				resource.removeReadyObserver(this);
//				if (num%1024==0)
//					log("commit - "+num);
//			}
//		});;
		return rsFuture;
		
	}
}
