package org.postgresql.core.netty;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

public class ChannelInboundHandler extends SimpleChannelInboundHandler<ByteBuf> {
	private final ByteBufInputStream stream;
	
	public ChannelInboundHandler(ByteBufInputStream stream) {
		this.stream = stream;
	}
	
	@Override
	public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause)
			throws Exception {
		stream.close();
		stream.markClosed();
	}
	static void log(String s) {
//		System.out.println(""+System.nanoTime()+" - "+s);
	}

	@Override
	protected void channelRead0(ChannelHandlerContext ctx, ByteBuf msg) throws Exception {
//		log("received - " + msg);
		msg.retain();
		stream.addByteBuf(msg);
	}
	
	public ByteBufInputStream getStream() {
		return stream;
	}
}
