/*-------------------------------------------------------------------------
*
* Copyright (c) 2004-2011, PostgreSQL Global Development Group
*
*
*-------------------------------------------------------------------------
*/
package org.postgresql.jdbc4;

import java.util.Map;
import java.util.Properties;
import java.sql.DatabaseMetaData;
import java.sql.SQLClientInfoException;
import java.sql.SQLException;
import java.sql.Savepoint;

import net.piraku.concurrent.FutureResource;
import net.piraku.core.Observers;
import net.piraku.sql.CallableStatementResource;
import net.piraku.sql.PreparedStatementResource;
import net.piraku.sql.StatementResource;

import org.postgresql.util.HostSpec;

/**
 * This class implements the java.sql.Connection interface for JDBC4.
 * However most of the implementation is really done in
 * org.postgresql.jdbc4.AbstractJdbc4Connection or one of it's parents
 */
public class Jdbc4Connection extends AbstractJdbc4Connection implements net.piraku.sql.ConnectionResource
{
	
	Observers observers = new Observers(this);
	
	public boolean isReady() { return true;};
	
	public void awaitReady() throws InterruptedException {};
	
	public void awaitReady(long timeout, java.util.concurrent.TimeUnit unit) throws InterruptedException ,java.util.concurrent.TimeoutException {};
	
	public void registerReadyObserver(net.piraku.core.PirakuResource.Observer observer) {
		observers.registerReadyObserver(observer);
	};
	public void removeReadyObserver(net.piraku.core.PirakuResource.Observer observer) {
		observers.removeReadyObserver(observer);
	};
	
	@Override
	public FutureResource<Boolean> getAutoCommitAsync() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public FutureResource<String> getCatalogAsync() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public FutureResource<Properties> getClientInfoAsync() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public FutureResource<String> getClientInfoAsync(String name)
			throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public FutureResource<Integer> getHoldabilityAsync() throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}
	@Override
	public FutureResource<DatabaseMetaData> getMetaDataAsync()
			throws SQLException {
		// TODO Auto-generated method stub
		return null;
	}
	
	
    public Jdbc4Connection(HostSpec[] hostSpecs, String user, String database, Properties info, String url) throws SQLException {
        super(hostSpecs, user, database, info, url);
    }

    public StatementResource createStatement(int resultSetType, int resultSetConcurrency, int resultSetHoldability) throws SQLException
    {
        checkClosed();
        Jdbc4Statement s = new Jdbc4Statement(this, resultSetType, resultSetConcurrency, resultSetHoldability);
        s.setPrepareThreshold(getPrepareThreshold());
        return s;
    }


    public PreparedStatementResource prepareStatement(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability) throws SQLException
    {
        checkClosed();
        Jdbc4PreparedStatement s = new Jdbc4PreparedStatement(this, sql, resultSetType, resultSetConcurrency, resultSetHoldability);
        s.setPrepareThreshold(getPrepareThreshold());
        return s;
    }

    public CallableStatementResource prepareCall(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability) throws SQLException
    {
        checkClosed();
        Jdbc4CallableStatement s = new Jdbc4CallableStatement(this, sql, resultSetType, resultSetConcurrency, resultSetHoldability);
        s.setPrepareThreshold(getPrepareThreshold());
        return s;
    }

    public java.sql.DatabaseMetaData getMetaData() throws SQLException
    {
        checkClosed();
        if (metadata == null)
            metadata = new Jdbc4DatabaseMetaData(this);
        return metadata;
    }

    public void setTypeMap(Map < String, Class < ? >> map) throws SQLException
    {
        setTypeMapImpl(map);
    }


}
